"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const prop_types_1 = __importDefault(require("prop-types"));
const cloneDeep_1 = __importDefault(require("lodash/cloneDeep"));
const styles_1 = require("./styles");
const HeadingsMapper = ({ headings, mapToHeadings, handleAccept: handleAcceptReturn, errorCallback, }) => {
    // check if any headings already match
    const initialMappings = headings.reduce((p, c) => {
        const r = Object.assign({}, p);
        if (mapToHeadings.map((h) => h.uid).indexOf(c) !== -1)
            r[c] = c;
        return r;
    }, {});
    const [mappedHeadingsInput, setMappedHeadingsInput] = (0, react_1.useState)(initialMappings);
    const mapToHeadingsSelect = () => mapToHeadings
        .map((h) => react_1.default.createElement("option", { value: h.uid }, h.label))
        .concat(react_1.default.createElement("option", { value: "" }, "NA"));
    const handleChange = (source, target) => {
        const newMappedHeadingsInput = (0, cloneDeep_1.default)(mappedHeadingsInput);
        newMappedHeadingsInput[source] = target;
        setMappedHeadingsInput(newMappedHeadingsInput);
    };
    const handleAccept = () => {
        // TODO: Check no duplicates
        const vals = Object.values(mappedHeadingsInput).filter((v) => v);
        const uniqueVals = new Set(vals);
        if (vals.length !== uniqueVals.size) {
            errorCallback(new Error('Mappings must be unique'));
            return;
        }
        const acceptedHeadings = headings.map((h) => mappedHeadingsInput[h] || h);
        handleAcceptReturn(acceptedHeadings);
    };
    const mappedHeadings = headings.map((h) => (react_1.default.createElement("li", { key: h, className: "headingsMapper_heading" },
        react_1.default.createElement("label", { htmlFor: `headingSelect_${h}` }, h),
        react_1.default.createElement("select", { id: `headingSelect_${h}`, value: mappedHeadingsInput[h] || '', onChange: (e) => handleChange(h, e.target.value) }, mapToHeadingsSelect()))));
    return (react_1.default.createElement("div", { className: "headingsMapper", "data-testid": "lfu-headingsMapper" },
        react_1.default.createElement("form", { onSubmit: (e) => {
                e.preventDefault();
                handleAccept();
            } },
            react_1.default.createElement(styles_1.MappedHeadingsList, null, mappedHeadings),
            react_1.default.createElement("button", { type: "button", className: "button-two headingsAcceptButton", onClick: handleAccept }, "Accept Headings Mapping"))));
};
HeadingsMapper.propTypes = {
    headings: prop_types_1.default.arrayOf(prop_types_1.default.string).isRequired,
    // @ts-ignore
    mapToHeadings: prop_types_1.default.arrayOf(prop_types_1.default.shape({
        uid: prop_types_1.default.string.isRequired,
        label: prop_types_1.default.string,
    })).isRequired,
    handleAccept: prop_types_1.default.func.isRequired,
    errorCallback: prop_types_1.default.func,
};
HeadingsMapper.defaultProps = {
    errorCallback: alert,
};
exports.default = HeadingsMapper;
//# sourceMappingURL=HeadingsMapper.js.map