"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const react_2 = require("@testing-library/react");
const user_event_1 = __importDefault(require("@testing-library/user-event"));
const local_file_uploader_1 = require("./local-file-uploader");
const defaultProps = {
    label: 'Example',
    onAccept: jest.fn(),
    onChange: jest.fn(),
    mapToHeadings: [],
    showAcceptButton: true,
};
describe('Local File Uploader', () => {
    it('should render the component', () => {
        (0, react_2.render)(react_1.default.createElement(local_file_uploader_1.LocalFileUploader, Object.assign({}, defaultProps)));
        expect(react_2.screen.getByText('Upload local file')).toBeInTheDocument();
    });
    it('should call the onChange function when a file is uploaded', () => {
        const onChange = jest.fn();
        (0, react_2.render)(react_1.default.createElement(local_file_uploader_1.LocalFileUploader, Object.assign({}, defaultProps, { onChange: onChange })));
        const input = react_2.screen.getByLabelText('Upload local file');
        user_event_1.default.upload(input, new File(['(⌐□_□)'], 'chucknorris.png', { type: 'image/png' }));
        expect(onChange).toHaveBeenCalledTimes(1);
    });
});
//# sourceMappingURL=local-file-uploader.spec.js.map